------------------------------------------------------------------------------
--                                                                          --
--                               GNATemulator                               --
--                                                                          --
--                       Copyright (C) 2011, AdaCore                        --
--                                                                          --
-- GNATemulator is free software; you can redistribute it  and/or modify it --
-- under terms of the GNU General Public License as published by the Free   --
-- Software Foundation; either version 2, or (at your option) any later     --
-- version. GNATemulator is distributed in the hope that it will be useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHAN-  --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details. You  should  have  received a copy of the GNU --
-- General Public License  distributed with GNAT; see file COPYING. If not, --
-- write  to  the Free  Software  Foundation,  59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------

with Glib; use Glib;

package body Data_Container is
   procedure Push (Data : Data_Container_Ref; Y : Bus_Data; X : Bus_Time) is
   begin
      for Index in Data.Y'First .. Data.Y'Last - 1 loop
         Data.Y (Index) := Data.Y (Index + 1);
         Data.X (Index) := Data.X (Index + 1);
      end loop;

      Data.Y (Data.Y'Last) := Gdouble (Y);
      Data.X (Data.X'Last) := Gdouble (X) / 1000000000.0;
   end Push;

   procedure Reset (Data : Data_Container_Ref) is
   begin
      for Index in Data.Y'First .. Data.Y'Last loop
         Data.Y (Index) := 0.0;
         Data.X (Index) := 0.0;
      end loop;
   end Reset;

end Data_Container;
