------------------------------------------------------------------------------
--                                                                          --
--                               GNATemulator                               --
--                                                                          --
--                       Copyright (C) 2011, AdaCore                        --
--                                                                          --
-- GNATemulator is free software; you can redistribute it  and/or modify it --
-- under terms of the GNU General Public License as published by the Free   --
-- Software Foundation; either version 2, or (at your option) any later     --
-- version. GNATemulator is distributed in the hope that it will be useful, --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHAN-  --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details. You  should  have  received a copy of the GNU --
-- General Public License  distributed with GNAT; see file COPYING. If not, --
-- write  to  the Free  Software  Foundation,  59 Temple Place - Suite 330, --
-- Boston, MA 02111-1307, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------

with Bus_Types; use Bus_Types;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package Data_Container is

   type Data_Container_Record is record
      Name : Unbounded_String;
      X    : Bus_Time;
      Y    : Bus_Data;
   end record;

   type Data_Container_Ref is access all Data_Container_Record;

   procedure Push (Data : Data_Container_Ref; Y : Bus_Data; X : Bus_Time);
   procedure Reset (Data : Data_Container_Ref);

end Data_Container;
